VAR
		long	cog
		long	pRENDEZVOUS

PUB start : okay
	stop
	rendezvous_ptr := @pRENDEZVOUS
	okay := COGNEW(@entry, 0) + 1

PUB stop
	if cog
		cogstop(cog~ - 1)

PUB rendevous
	return @pRENDEZVOUS

DAT
		org	0
entry
		jmp	#startup
rendezvous_ptr	long	0-0
lcd_text_ptr	long	@@@lcd_text
ldc_x		long	0
lcd_y		long	0
x20202020	long	$20202020
latch_dir	long	%00000000_00000000_00001111_11111111	' 138 active, gate active and 8 data lines active
latch_lcd	long	%00000000_00000000_00001011_00000000	' LCD latch is xxxx101x and gate high xxxxxxx1
enable_lcd	long	%00000000_00000000_00000000_00000010	' Enable pin 6 on LCD displays
lcd_delay	long	500_000
lcd_or		long	0					' used to send either command or data nibbles


startup
		call	#lcd_init
command		rdlong	data, rendezvous_ptr	WZ
	if_z	jmp	command
		and	data, #$ff
lcd_out

		cmp	data, #8		WZ
	if_z	jmp	#lcd_bsp
		cmp	data, #9		WZ
	if_z	jmp	#lcd_tab
		cmp	data, #10		WZ
	if_z	jmp	#lcd_lf
		cmp	data, #12		WZ
	if_z	jmp	#lcd_cls
		cmp	data, #13		WZ
	if_z	jmp	#lcd_cr
		call	#lcd_out_char
		jmp	#command

lcd_out_char
		mov	lcd_ptr, lcd_y
		shl	lcd_ptr, #2			' * 4
		add	lcd_ptr, lcd_y			' * 5
		shl	lcd_ptr, #3			' * 8
		add	lcd_ptr, lcd_x
		add	lcd_ptr, lcd_text_ptr
		wrbyte	data, lcd_ptr
		call	#lcd_send_text
		add	lcd_x, #1
		cmp	lcd_x, #40		WZ
	if_nz	jmp	#lcd_out_char_ret
		mov	lcd_x, #0
		add	lcd_y, #1
		cmp	lcd_y, #4		WZ
	if_nz	jmp	#lcd_out_char_ret
		call	#lcd_scroll
		mov	lcd_y, #3
		call	#lcd_set_cursor
lcd_char_out_ret
		ret

lcd_set_cursor
		mov	data, lcd_y
		shl	data, #2			' * 4
		add	data, lcd_y			' * 5
		shl	data, #3			' * 8
		add	data, lcd_x
		add	data, lcd_text_ptr
		add	data, #$80			' first half of the 4 lines
		cmp	data, #$80+2*40		WC
	if_ae	add	data, #$40-2*40			' adjust to second half of the 4 lines
		call	#lcd_send_inst
lcd_set_cursor
		ret

lcd_bsp
		cmp	lcd_x, #0		WZ
	if_z	jmp	#:row_up
		sub	lcd_x, #1
		call	#lcd_set_cursor
		jmp	#command
:row_up
		cmp	lcd_y, #0		WZ
	if_z	jmp	#command
		sub	lcd_y, #1
		mov	lcd_x, #39
		call	#lcd_set_cursor
		jmp	#command

lcd_tab
		mov	data, #32
		call	#lcd_out_char
		test	lcd_x, #7		WZ
	if_nz	jmp	#tab
		jmp	#command

lf
		add	lcd_y, #1
		cmp	lcd_y, #4		WZ
	if_nz	jmp	:ok
		call	#lcd_scroll
		mov	lcd_y, #3
:ok
		call	#lcd_set_cursor
		jmp	#command

lcd_cls
		mov	lcd_ptr, lcd_text_ptr
		mov	t3, #40*4/4
:loop
		wrlong	x20202020, lcd_ptr
		add	lcd_ptr, #4
		djnz	t3, #:loop
		mov	data, #1			' CLS instruction
		call	#lcd_send_inst
		mov	lcd_x, #0
		mov	lcd_y, #0
		call	#lcd_set_cursor
		jmp	#command

cr
		mov	lcd_x, #0
		call	#lcd_set_cursor
		jmp	#command

lcd_scroll
		mov	t1, lcd_text_ptr
		mov	t2, #40
		mov	t3, #40*3/4
:loop
		add	t1, t2
		rdlong	data, t1
		sub	t1, t2
		wrlong	data, t1
		djnz	t3, #:loop
lcd_redraw
		mov	data, #$80			' to position 1
		call	#lcd_send_inst
		mov	lcd_ptr, lcd_text_ptr
		mov	t3, #40*4
:loop
		rdbyte	data, lcd_ptr
		add	lcd_ptr, #1
		call	#lcd_send_text
		djnz	t3, #:loop
lcd_redraw_ret
lcd_scroll_ret
		ret

lcd_init
		mov	t1, #%00001100			' send out 0011 already shifted to xxnnnnxx
		call	#lcd_pulse_out
		mov	t1, #%00001100			' send out 0011 already shifted to xxnnnnxx
		call	#lcd_pulse_out
		mov	t1, #%00001100			' send out 0011 already shifted to xxnnnnxx
		call	#lcd_pulse_out
		mov	t1, #%00001000			' send out 0010 already shifted to xxnnnnxx
		call	#lcd_pulse_out
		mov	t1, #%00001000			' send out 0010 already shifted to xxnnnnxx
		call	#lcd_pulse_out
		mov	t1, #%00100000			' send out 1000 already shifted to xxnnnnxx
		call	#lcd_pulse_out
		mov	data, #14			' cursor on
		call	#lcd_send_inst
		mov	data, #1			' clear screen
		call	#lcd_send_inst
		mov	data, #13			' flashing cursor
		call	#lcd_send_inst
		mov	data, #$80			' to position 1
		call	#lcd_send_inst
lcd_init_ret
		ret

lcd_send_text
		mov	lcd_or, #%00000001
		jmp	#lcd_send
lcd_send_inst
		mov	lcd_or, #%00000000
lcd_send
		mov	t1, data
		shr	t1, #2
		and	t1, #%00111100
		or	t1, lcd_or
		call	#lcd_pulse_out
		mov	t1, data
		shl	t1, #2
		and	t1, #%00111100
		or	t1, lcd_or
		call	#lcd_pulse_out
lcd_send_ret
lcd_send_inst_ret
lcd_send_text_ret
		ret

lcd_pulse_out
		or	t1, enable_lcd		' enable pin high
		call	#lcd_output
		mov	t2, lcd_delay
		add	t2, CNT
		waitcnt	t2, lcd_delay
		andn	t1, enable_lcd		' enable pin low
		call	#lcd_output
		waitcnt	t2, lcd_delay
lcd_pulse_out_ret
		ret

lcd_output
		mov	dira, latch_dir		' set latch direction
		and	t1, #$ff
		or	t1, latch_lcd		' latch LCD with gate on
		mov	outa, t1
		andn	t1, #%1_00000000	' toggle gate off
		mov	outa, t1
		mov	dira, #0		' tristate the outputs
lcd_output_ret
		ret

		fit	$1f0

lcd_text	byte	0[40*4]
